package com.platform.controller;

import java.util.List;
import java.util.Map;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.Result;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.platform.entity.CollectEntity;
import com.platform.service.CollectService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;



/**
 * 
 * 
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-13 10:41:06
 */
@RestController
@RequestMapping("collect")
public class CollectController {
	@Autowired
	private CollectService collectService;
	
	/**
	 * 列表
	 */
	@RequestMapping("/list")
	@RequiresPermissions("collect:list")
	public Result list(@RequestBody Map<String, Object> params){
		//查询列表数据
        Query query = new Query(params);

		List<CollectEntity> collectList = collectService.queryList(query);
		int total = collectService.queryTotal(query);
		
		PageUtils pageUtil = new PageUtils(collectList, total, query.getLimit(), query.getPage());
		
		return Result.success(pageUtil);
	}
	
	
	/**
	 * 信息
	 */
	@RequestMapping("/info/{id}")
	@RequiresPermissions("collect:info")
	public Result info(@PathVariable("id") Integer id){
		CollectEntity collect = collectService.queryObject(id);
		
		return Result.success(collect);
	}
	
	/**
	 * 保存
	 */
	@CanUserUpdateRecord
	@RequestMapping("/save")
	@RequiresPermissions("collect:save")
	public Result save(@RequestBody CollectEntity collect){
		collectService.save(collect);
		
		return Result.success();
	}
	
	/**
	 * 修改
	 */
	@CanUserUpdateRecord
	@RequestMapping("/update")
	@RequiresPermissions("collect:update")
	public Result update(@RequestBody CollectEntity collect){
		collectService.update(collect);
		
		return Result.success();
	}
	
	/**
	 * 删除
	 */
	@CanUserUpdateRecord
	@RequestMapping("/delete")
	@RequiresPermissions("collect:delete")
	public Result delete(@RequestBody Integer[] ids){
		collectService.deleteBatch(ids);
		
		return Result.success();
	}
	
}
